'From Squeak3.9 of 7 November 2006 [latest update: #7067] on 2 July 2007 at 1:27:08 pm'!
Object subclass: #Money
	instanceVariableNames: 'currency amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Money'!
TestCase subclass: #TestMoney
	instanceVariableNames: 'chf2 chf8 chf10'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Money'!

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:21'!
!!= aMoney
	^ (self = aMoney) not! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:26'!
+ aMoney
	self assert: [ self currency = aMoney currency ].
	^ Money currency: self currency amount: self amount + aMoney amount! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:20'!
= aMoney
	^ self amount = aMoney amount and: [ self currency = aMoney currency ]! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
amount
	^ amount! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
amount: aNumber
	amount := aNumber! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:17'!
currency
	^ currency! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
currency: aString
	currency := aString! !


!Money class methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:23'!
currency: aCurrency amount: anAmount
	^  self new currency: aCurrency; amount: anAmount; yourself! !


!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:23'!
setUp
	chf2 := Money currency: 'CHF' amount: 2.
	chf8 := Money new currency: 'CHF'; amount: 8.
	chf10 := Money new currency: 'CHF'; amount: 10.! !

!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:25'!
testAdd
	self assert: chf2 + chf8 = chf10
! !

!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:17'!
testEquals
	self assert: chf2 = chf2.
	self assert: chf2 = (Money new currency: 'CHF'; amount: 2).
	self assert: chf2 !!= chf8.
! !

